pipeline {
    agent any

    stages {
        stage('InstallWireguard') {
            steps {
                sh 'sudo apt install wireguard'
            }
        }
        stage('GenerateCertificates') {
            steps {
                sh 'wg genkey | tee client_private_key.txt | wg pubkey > client_public_key.txt'
                archiveArtifacts artifacts: '**/*.txt', followSymlinks: false
            }
        }
        stage('CreateClientConfig') {
             steps {
                 git branch: 'main', url: 'https://gitlab.com/balpreet.singh1/wireguardtemplate'
                 sh "myVar=`cat /var/lib/jenkins/workspace/wireguard/wireguardClientSetup/client_private_key.txt`"
                 sh '''chmod 755 createtemplate.sh
                      sudo  ./createtemplate.sh'''
                      sh '''chmod 755 templateForServer.sh
                      sudo  ./templateForServer.sh'''
                 archiveArtifacts artifacts: '**/*.conf', followSymlinks: false
                 archiveArtifacts artifacts: '**/*.txt', followSymlinks: false
                 sh 'sudo cp wg0-client.conf /etc/wireguard/wg0-client.conf'

                }
                }
        

    }
}

